# We can't let RPM do the dependencies automatic because it'll then pick up
# a correct but undesirable perl dependency, which rkhunter does not require
# in order to function properly [perl(Digest::MD5) & perl(Digest::SHA1)].
AutoReqProv:    no

Name:           rkhunter
Version:        1.1.8
Release:        0.fdr.1
Epoch:          0
Summary:        Rootkit Hunter scans for rootkits, backdoors and local exploits.

Group:          Applications/System
License:        GPL
URL:            http://www.rootkit.nl/
Source0:        http://downloads.rootkit.nl/rkhunter-1.1.8.tar.gz
Source1:        rkhunter-scan_on_boot-rc.local.tar.gz
Source2:        rkhunter-1.1.8-0.fdr.1.src.md5
Patch1:         rkhunter-1.1.8-whitelist_dir-conf.patch
Patch2:         rkhunter-1.1.8-showfiles.patch
Patch3:         rkhunter-1.1.8-shared_man_search.patch
Patch4:         rkhunter-1.1.8-app_check_default.patch
Patch5:         rkhunter-1.1.8-prelink_cleanup.patch
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       /bin/sh, coreutils, binutils, modutils, findutils, grep
Requires:       e2fsprogs, procps, lsof, prelink, iproute, net-tools
Requires:       perl, perl(strict), perl(IO::Socket), nmap, mailx

%description
Rootkit Hunter is a scanning tool to ensure that you're about 99.9%%
clean of nasty tools.  This tool scans for rootkits, backdoors and local
exploits by running tests like:
        - MD5 hash compare
        - Look for default files used by rootkits
        - Wrong file permissions for binaries
        - Look for suspected strings in LKM and KLD modules
        - Look for hidden files
        - Optional scan within plaintext and binary files
        - Software version checks
        - Application tests

Rootkit Hunter is released as a GPL licensed project and
is free for everyone to use.


%prep

# This optional check is for verification of original sources
# DURING the binary build process (md5 canary check)
#[ ! -e %{_sourcedir}/%{name}-%{version}-0.fdr.1.src.md5.orig ] \
#    && %{__perl} -pi.orig -e '
#	s|../SOURCES|%{_sourcedir}|g;
#     ' %{_sourcedir}/%{name}-%{version}-0.fdr.1.src.md5
#md5sum --check %{_sourcedir}/%{name}-%{version}-0.fdr.1.src.md5 || exit $?

%setup -q -n %{name}
%setup -q -D -T -a 1 -n %{name}

%{__perl} -pi.orig -e '
	s|\@RKLIB\@|%{_libdir}/%{name}|g;
	s|\@RCDIR\@|%{_sysconfdir}/rc.d|g;
	s|\@LGDIR\@|%{_localstatedir}/log|g;
    ' rkhunter-scan_on_boot

%{__perl} -pi.orig -e '
	s|\@RCDIR\@|%{_sysconfdir}/rc.d|g;
	s|\@ITDIR\@|%{_initrddir}|g;
	s|\@SCDIR\@|%{_sysconfdir}/sysconfig|g;
	s|\@RKEXE\@|%{_bindir}/%{name}|g;
    ' rkhunter-scan_on_boot-rc.local

%patch1 -b .orig
%patch2 -b .orig
%patch3 -b .orig
%patch4 -b .0001
%patch5 -b .0002

%{__cat} <<'EOF' >%{name}.sysconfig
# System configuration file for Rootkit Hunter which
# stores RPM system specifics for rc.local, etc.

RKHUNTER_FLAGS="
    --quiet
    --create-logfile
"
EOF

%{__cat} <<'EOF' >%{name}.conf
## Next three lines installed automatically by RPM. Do not change
## unless you know what you're doing...
INSTALLDIR=%{_prefix}
DBDIR=%{_var}/%{name}/db
TMPDIR=%{_var}/%{name}/tmp

EOF
%{__cat} files/%{name}.conf >> %{name}.conf

%{__cat} <<'EOF' >01-%{name}
#!/bin/sh
%{_bindir}/%{name} --cronjob | /bin/mail -s '%{name} Daily Run' root
EOF


%build
#%%configure
# We have nothing to configure... yet...


%install
%{__rm} -rf ${RPM_BUILD_ROOT}

%{__mkdir} -m755 -p ${RPM_BUILD_ROOT}%{_bindir}
%{__mkdir} -m755 -p ${RPM_BUILD_ROOT}%{_sysconfdir}/{cron.daily,sysconfig}
%{__mkdir} -m750 -p ${RPM_BUILD_ROOT}%{_libdir}/%{name}/{scripts,rc.d}
%{__mkdir} -m755 -p ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}
%{__mkdir} -m755 -p ${RPM_BUILD_ROOT}%{_mandir}/man8
%{__mkdir} -m750 -p ${RPM_BUILD_ROOT}%{_var}/%{name}/{db,tmp}

%{__install} -m750 -p files/%{name}             ${RPM_BUILD_ROOT}%{_bindir}/

%{__install} -m640 -p files/backdoorports.dat   ${RPM_BUILD_ROOT}%{_var}/%{name}/db/
%{__install} -m640 -p files/defaulthashes.dat   ${RPM_BUILD_ROOT}%{_var}/%{name}/db/
%{__install} -m640 -p files/md5blacklist.dat    ${RPM_BUILD_ROOT}%{_var}/%{name}/db/
%{__install} -m640 -p files/mirrors.dat         ${RPM_BUILD_ROOT}%{_var}/%{name}/db/
%{__install} -m640 -p files/os.dat              ${RPM_BUILD_ROOT}%{_var}/%{name}/db/
%{__install} -m640 -p files/programs_bad.dat    ${RPM_BUILD_ROOT}%{_var}/%{name}/db/
%{__install} -m640 -p files/programs_good.dat   ${RPM_BUILD_ROOT}%{_var}/%{name}/db/

%{__install} -m644 -p files/CHANGELOG           ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
%{__install} -m644 -p files/LICENSE             ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
%{__install} -m644 -p files/README              ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
%{__install} -m644 -p files/WISHLIST            ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
%{__install} -m644 -p rkhunter-scan_on_boot     ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/BOOTSCAN

%{__install} -m644 -p files/development/*.8     ${RPM_BUILD_ROOT}%{_mandir}/man8/

%{__install} -m750 -p files/check_modules.pl    ${RPM_BUILD_ROOT}%{_libdir}/%{name}/scripts/
%{__install} -m750 -p files/check_port.pl       ${RPM_BUILD_ROOT}%{_libdir}/%{name}/scripts/
%{__install} -m750 -p files/check_update.sh     ${RPM_BUILD_ROOT}%{_libdir}/%{name}/scripts/
%{__install} -m750 -p files/filehashmd5.pl      ${RPM_BUILD_ROOT}%{_libdir}/%{name}/scripts/
%{__install} -m750 -p files/filehashsha1.pl     ${RPM_BUILD_ROOT}%{_libdir}/%{name}/scripts/
%{__install} -m750 -p files/showfiles.pl        ${RPM_BUILD_ROOT}%{_libdir}/%{name}/scripts/
%{__install} -m750 -p 01-%{name}                ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.daily/
%{__install} -m750 -p rkhunter-scan_on_boot-rc.local ${RPM_BUILD_ROOT}%{_libdir}/%{name}/rc.d/rc.local
%{__install} -m640 -p %{name}.conf              ${RPM_BUILD_ROOT}%{_sysconfdir}/
%{__install} -m640 -p %{name}.sysconfig         ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}


%clean
%{__rm} -rf $RPM_BUILD_ROOT
# Autoclean for rpmbuild -bb
#cd ..
#%{__rm} -rf %{name}


%postun
if [ "$1" = 0 ]; then
    [ ! -d %{_var}/%{name} ] || %{__rm} -rf %{_var}/%{name}
    [ ! -d %{_libdir}/%{name} ] || %{__rm} -rf %{_libdir}/%{name}
fi


%files
%defattr(-,root,root,-)
%{_bindir}/%{name}
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/scripts
%{_libdir}/%{name}/rc.d
%{_sysconfdir}/cron.daily/01-%{name}
%dir %{_var}/%{name}
%{_var}/%{name}/db
%dir %{_var}/%{name}/tmp
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/*
%{_mandir}/man8/*


%changelog
* Fri Oct 15 2004 Greg Houlette - 0:1.1.8-0.fdr.1 (revisited)
- Removed redundant buildrequires /bin/sh, coreutils and perl
- Revise postun scriptlet
- Added /usr/share/doc/rkhunter-1.1.8/ to files list

* Mon Oct 11 2004 Greg Houlette - 0:1.1.8-0.fdr.1
- Changed Release Tag to 0.fdr.1 (testing) for QA
- Removed wget from dependencies
- Hid (temporarily) the --skip-application-check command
  line option from being listed in help
- Fixed the spec files list, again!

* Fri Oct 8 2004 Greg Houlette - 0:1.1.8-0.fdr.0.2.beta2
- Unified and disabled the md5 canary check in prep
  (check is now optional) removing the sha1 cross-check
- Fixed the spec files list, adding the /var/rkhunter
  directory and the /usr/bin/rkhunter executable
- Fixed missing dependencies (rkh uses runtime checks)
- Disabled "auto-clean" for rpmbuild -bb
- Changed Application version scan default to
  disabled awaiting backport fix in upstream sources
- Fixed shared_man_search.patch, configuration files
  verify and added postun(install) cleanup

* Fri Oct 1 2004 Greg Houlette - 0:1.1.8-0.fdr.0.1.beta1
- More cosmetic patchwork
- Changed Release Tag to beta1 (pre-release) for QA submit

* Tue Sep 28 2004 Greg Houlette - 0:1.1.8-0.fdr.1
- Removed hidden_search.patch (1.1.7) after it was
  merged into upstream source by Michael Boelen
- Removed .spec file from md5 and sha1 file checks
  (it must be modifiable by Fedora QA release build)
- Added BOOTSCAN description file to documentation
- Restructured dynamic file creation ('Here' Docs)
  moving them to the "prep" stage so that *_ALL_*
  files are available prior to the "build" stage
  (for inspection purposes)
- Added a /etc/sysconfig/rkhunter parameters file

* Sun Aug 29 2004 Greg Houlette - 0:1.1.7-0.fdr.1
- Cosmetic patchwork

* Sat Aug 21 2004 Greg Houlette - 0:1.1.6-0.fdr.1
- Moderate reworking of .spec file for packaging standards
- Added md5 and sha1 file checks to prep procedure for source .rpm
- Included an optional rc.local replacement for scan on boot (with full logging)

* Tue Aug 10 2004 Michael Boelen - 1.1.5
- Added update script
- Extended description

* Sun Aug 08 2004 Greg Houlette - 1.1.5
- Changed the install procedure eliminating the specification of
  destination filenames (only needed if you are renaming during install)
- Changed the permissions for documentation files (root only overkill)
- Added the installation of the rkhunter Man Page
- Added the installation of the programs_{bad, good}.dat database files
- Added the installation of the LICENSE documentation file
- Added the chmod for root only to the /var/rkhunter/db directory

* Sun May 23 2004 Craig Orsinger (cjo) <cjorsinger@earthlink.net>
- version 1.1.0-1.cjo
- changed installation in accordance with new rootkit installation
  procedure
- changed installation root to conform to LSB. Use standard macros.
- added recursive remove of old build root as prep for install phase

* Wed Apr 28 2004 Doncho N. Gunchev - 1.0.9-0.mr700
- dropped Requires: perl - rkhunter works without it 
- dropped the bash alignpatch (check the source or contact me)
- various file mode fixes (.../tmp/, *.db)
- optimized the %%files section - any new files in the
  current dirs will be fine - just %%{__install} them.

* Mon Apr 26 2004 Michael Boelen - 1.0.8-0
- Fixed missing md5blacklist.dat

* Mon Apr 19 2004 Doncho N. Gunchev - 1.0.6-1.mr700
- added missing /usr/local/rkhunter/db/md5blacklist.dat
- patched to align results in --cronjob, I think rpm based
  distros have symlink /bin/sh -> /bin/bash
- added --with/--without alignpatch for conditional builds
  (in case previous patch breaks something)

* Sat Apr 03 2004 Michael Boelen / Joe Klemmer - 1.0.6-0
- Update to 1.0.6

* Mon Mar 29 2004 Doncho N. Gunchev - 1.0.0-0
- initial .spec file
